
#ifndef SERIAL2WIFI_SPI_CLIENT_H
#define SERIAL2WIFI_SPI_CLIENT_H

#include <bcm2835.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>


#define DATA_READY_PIN_1  RPI_GPIO_P1_12
#define MANUAL_SPI_CS_1   RPI_GPIO_P1_13
#define DATA_READY_PIN_2  RPI_GPIO_P1_15


class Serial2Wifi_SPI_Client
{
public:
	Serial2Wifi_SPI_Client();

	void initialize(int baudRate = 115200);
	void initializeQuietly(int baudRate = 115200);
	void close();

	int getBaudRate();

	void sendInitData();

	int sendCommandBlocking(const char *command, char *buffer = 0);
	int sendCommandNonBlocking(const char *command);

	int sendDataBlocking(char *txBuffer, int txSize, char *rxBuffer, int rxSize);
	int sendDataNonBlocking(char *txBuffer, int txSize);

	int sendData(const char* txBuffer, int txSize = 0);
	int recvCommandResult(char* rxBuffer);
	int recvData(char* rxBuffer, int rxSize = 10000);

	double setReadTimeout(double timeout);
	double getReadTimeout();

	double setWriteTimeout(double timeout);
	double getWriteTimeout();

	void  pulseCS();

private:
	bool initialized;
	bool first_run;

	int data_ready_pin;
	int manual_cs;


	double readTimeout;
	double writeTimeout;

	int data_ready();
	void print_reply( char* read_ptr, int how_many );
};

#endif 

